/*
<one line to give the program's name and a brief idea of what it does.>
Copyright (C) <year>  <name of author>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef CPPPROPERTYCREATOR_H
#define CPPPROPERTYCREATOR_H

#include "propertcreator.h"
#include <QString>
#include <QList>
class CppPropertyCreator : public PropertyCreator
{
public:
    bool parse (PropertyModel * m, ClassDeclaration* klass, ClassMemberDeclaration* selectedMember = 0);
    void create (PropertyModel * m);
private:
    class CodeRange
    {
    public:
        CodeRange() : lineStart (0), lineEnd (0) {}
        CodeRange (const QString & n) : lineStart (0), lineEnd (0), name (n) {}
        CodeRange (const QString & n, int s, int e) : lineStart (s), lineEnd (e), name (n) {}
        virtual ~CodeRange() {}
        int lineStart;
        int lineEnd;
        QString name;
        virtual bool isNull()
        {
            return name.isEmpty();
        }
    };
    class NullCodeRange : public CodeRange
    {
    public:
        bool isNull()
        {
            return true;
        }
    };
    QList<CodeRange> m_ranges;
    CodeRange &getRange (const QString &name);
    int getRangeIndex (const QString &name);

    QString readerName (const QString &property);
    QString writerName (const QString &property);
    QString propertyName (const QString &property);
    QString propertyAlias (const QString &property);
    QString readerType (const QString &type);
    QString writerType (const QString &type);
};

#endif //CPPPROPERTYCREATOR_H

// kate: indent-mode cstyle; space-indent on; indent-width 4; replace-tabs on; 
