/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "propertydelegate.h"

AccessListDelegate::AccessListDelegate (QObject *parent) : QItemDelegate (parent)
{
}

QWidget * AccessListDelegate::createEditor (QWidget *parent, const QStyleOptionViewItem &option,
        const QModelIndex &index) const
{
    Q_UNUSED (index);
    Q_UNUSED (option);
    QComboBox * box = new QComboBox (parent);
    populateList (box);
    box->setAutoFillBackground (true);
    return box;
}

void AccessListDelegate::setEditorData (QWidget *editor, const QModelIndex &index) const
{
    QComboBox * box = dynamic_cast<QComboBox *> (editor);
    if (!box)
    {
        kDebug() << "Null editor";
        return;
    }

    //Selected
    QVariant sel =  index.model()->data (index, Qt::EditRole);
    box->setCurrentIndex (box->findData (sel, Qt::DisplayRole));

}
void AccessListDelegate::setModelData (QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const
{
    QComboBox * box = dynamic_cast<QComboBox *> (editor);
    if (!box)
    {
        kDebug() << "Null editor";
        return;
    }

    QVariant var = box->itemData (box->currentIndex(), Qt::DisplayRole);
    if (!var.isValid())
        return;

    model->setData (index, var, Qt::EditRole);
}

void AccessListDelegate::updateEditorGeometry (QWidget *editor, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    Q_UNUSED (index);
    QComboBox * box = dynamic_cast<QComboBox *> (editor);
    if (!box)
    {
        kDebug() << "Null editor";
        return;
    }
    QRect r = option.rect;
    r.setWidth (box->contentsRect().width());
    box->setGeometry (r);
}

void AccessListDelegate::populateList (QComboBox * box) const
{
    box->insertItem (0,"public");
    box->setItemData (0, "public", Qt::DisplayRole);
    box->insertItem (1,"protected");
    box->setItemData (1, "protected", Qt::DisplayRole);
    box->insertItem (2,"private");
    box->setItemData (2, "private", Qt::DisplayRole);
}

// kate: indent-mode cstyle; space-indent on; indent-width 4; replace-tabs on;  replace-tabs on;
