/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef PROPERTYNODE_H
#define PROPERTYNODE_H

#include <QtGui/QIcon>

namespace KDevelop
{
class ClassDeclaration ;
class ClassMemberDeclaration ;
}

class PropertyNode
{
public:
    PropertyNode ();
    virtual ~PropertyNode();

    /** Reader for readerName.
     *  @see readerName
     *  @return readerName
     */
    virtual const QString& readerName() const
    {
        return m_readerName;
    }

    /** Writer for readerName.
     *  @see readerName
     *  @param rn Value for readerName.
     */
    virtual void setReaderName (const QString& rn)
    {
        m_readerName = rn;
    }

    /** Reader for m_createReader.
     *  @see m_createReader
     *  @return m_createReader
     */
    virtual bool createReader() const
    {
        return m_createReader;
    }

    /** Writer for m_createReader.
     *  @see m_createReader
     *  @param cr Value for m_createReader.
     */
    virtual void setCreateReader (bool cr)
    {
        m_createReader = cr;
    }

    /** Reader for m_canCreateReader.
     *  @see m_canCreateReader
     *  @return m_canCreateReader
     */
    virtual bool canCreateReader() const
    {
        return m_canCreateReader;
    }

    /** Writer for m_canCreateReader.
     *  @see m_canCreateReader
     *  @param ccr Value for m_canCreateReader.
     */
    virtual void setCanCreateReader (bool ccr)
    {
        m_canCreateReader = ccr;
    }

    /** Reader for m_readerAccess.
     *  @see m_readerAccess
     *  @return m_readerAccess
     */
    virtual const QString& readerAccess() const
    {
        return m_readerAccess;
    }

    /** Writer for m_readerAccess.
     *  @see m_readerAccess
     *  @param ra Value for m_readerAccess.
     */
    virtual void setReaderAccess (const QString& ra)
    {
        m_readerAccess = ra;
    }

    /** Reader for writerName.
     *  @see writerName
     *  @return writerName
     */
    virtual const QString& writerName() const
    {
        return m_writerName;
    }

    /** Writer for writerName.
     *  @see writerName
     *  @param wn Value for writerName.
     */
    virtual void setWriterName (const QString& wn)
    {
        m_writerName = wn;
    }

    /** Reader for m_createWriter.
     *  @see m_createWriter
     *  @return m_createWriter
     */
    virtual bool createWriter() const
    {
        return m_createWriter;
    }

    /** Writer for m_createWriter.
     *  @see m_createWriter
     *  @param cw Value for m_createWriter.
     */
    virtual void setCreateWriter (bool cw)
    {
        m_createWriter = cw;
    }

    /** Reader for m_canCreateWriter.
     *  @see m_canCreateWriter
     *  @return m_canCreateWriter
     */
    virtual bool canCreateWriter() const
    {
        return m_canCreateWriter;
    }

    /** Writer for m_canCreateWriter.
     *  @see m_canCreateWriter
     *  @param ccw Value for m_canCreateWriter.
     */
    virtual void setCanCreateWriter (bool ccw)
    {
        m_canCreateWriter = ccw;
    }

    /** Reader for m_writerAccess.
     *  @see m_writerAccess
     *  @return m_writerAccess
     */
    virtual const QString& writerAccess() const
    {
        return m_writerAccess;
    }

    /** Writer for m_writerAccess.
     *  @see m_writerAccess
     *  @param wa Value for m_writerAccess.
     */
    virtual void setWriterAccess (const QString& wa)
    {
        m_writerAccess = wa;
    }

    /** Reader for m_type.
     *  @see m_type
     *  @return m_type
     */
    virtual const QString& type() const
    {
        return m_type;
    }

    /** Writer for m_type.
     *  @see m_type
     *  @param t Value for m_type.
     */
    virtual void setType (const QString& t)
    {
        m_type = t;
    }

    /** Reader for m_name.
     *  @see m_name
     *  @return m_name
     */
    virtual const QString& name() const
    {
        return m_name;
    }

    /** Writer for m_name.
     *  @see m_name
     *  @param n Value for m_name.
     */
    virtual void setName (const QString& n)
    {
        m_name = n;
    }

    /** Reader for m_icon.
     *  @see m_icon
     *  @return m_icon
     */
    virtual const QIcon& icon() const
    {
        return m_icon;
    }

    /** Writer for m_icon.
     *  @see m_icon
     *  @param i Value for m_icon.
     */
    virtual void setIcon (const QIcon& i)
    {
        m_icon = i;
    }
protected:
    QString m_readerName;
    bool m_createReader;
    bool m_canCreateReader;
    QString m_readerAccess;

    QString m_writerName;
    bool m_createWriter;
    bool m_canCreateWriter;
    QString m_writerAccess;

    QString m_type;
    QString m_name;
    QIcon m_icon;
};

#endif // PROPERTYNODE_H

// kate: indent-mode cstyle; space-indent on; indent-width 4; replace-tabs on;
